# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "schemaui"
version = "0.4.0"
authors = ["unic <yuniqueunic@gmail.com>"]
build = false
exclude = [
    "web/ui/node_modules/**",
    "web/ui/.vite/**",
    "web/ui/.tmp/**",
    "web/ui/.DS_Store",
    "docs/**/*.gif",
    "docs/**/*.mp4",
]
include = [
    "Cargo.toml",
    "keymap/default.keymap.json",
    "src/**",
    "web/dist/**",
    "README.md",
    "README.ZH.md",
    "LICENSE*",
]
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "A Rust library for generating TUI and Web UIs from JSON Schemas for configuration management."
documentation = "https://docs.rs/schemaui"
readme = "README.md"
keywords = [
    "tui",
    "schema",
    "configuration",
    "terminal",
    "cross-platform",
]
categories = [
    "command-line-interface",
    "config",
]
license = "MIT OR Apache-2.0"
repository = "https://github.com/yuniqueunic/schemaui"

[features]
all_formats = [
    "json",
    "yaml",
    "toml",
]
compile_time = []
debug = []
default = [
    "tui",
    "web",
    "json",
]
full = [
    "all_formats",
    "tui",
    "web",
]
json = []
toml = ["dep:toml"]
tui = []
web = [
    "dep:include_dir",
    "dep:axum",
    "dep:tokio",
    "dep:ts-rs",
]
yaml = ["dep:serde_yaml"]

[lib]
name = "schemaui"
path = "src/lib.rs"

[dependencies.anyhow]
version = "1"

[dependencies.axum]
version = "0.8"
features = [
    "macros",
    "json",
]
optional = true

[dependencies.crossterm]
version = "0.29.0"

[dependencies.include_dir]
version = "0.7"
optional = true

[dependencies.indexmap]
version = "2"

[dependencies.jsonschema]
version = "0.37"

[dependencies.percent-encoding]
version = "2"

[dependencies.ratatui]
version = "0.29.0"

[dependencies.regex]
version = "1"

[dependencies.schemars]
version = "0.8.22"
features = ["preserve_order"]

[dependencies.serde]
version = "1"
features = ["derive"]

[dependencies.serde_json]
version = "1"

[dependencies.serde_yaml]
version = "0.9"
optional = true

[dependencies.textwrap]
version = "0.16"

[dependencies.tokio]
version = "1"
features = [
    "macros",
    "rt-multi-thread",
    "signal",
    "net",
    "fs",
]
optional = true

[dependencies.toml]
version = "0.9"
optional = true

[dependencies.ts-rs]
version = "11"
features = ["serde-compat"]
optional = true

[dependencies.unicode-width]
version = "=0.2.0"

[profile.release]
opt-level = "z"
lto = true
codegen-units = 1
panic = "abort"
strip = "debuginfo"
